<template>
  <Dialog title="上传订单编号" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="商品名" prop="name">
        <el-input disabled v-model="formData.name" placeholder="请输入商品名" />
      </el-form-item>
      <el-form-item label="兑换积分" prop="point">
        <el-input disabled v-model="formData.point" placeholder="请输入兑换积分" />
      </el-form-item>
      <el-form-item label="联系人姓名" prop="contactName">
        <el-input disabled v-model="formData.contactName" placeholder="请输入联系人姓名" />
      </el-form-item>
      <el-form-item label="联系地址" prop="contactAddress">
        <el-input disabled v-model="formData.contactAddress" placeholder="请输入联系地址" />
      </el-form-item>
      <el-form-item label="联系电话" prop="contactPhone">
        <el-input disabled v-model="formData.contactPhone" placeholder="请输入联系电话" />
      </el-form-item>
      <el-form-item label="订单编号" prop="orderNo">
        <el-input v-model="formData.orderNo" placeholder="请输入订单编号" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { RedeemApi } from '@/api/menduner/system/redeem'

/** 兑换 表单 */
defineOptions({ name: 'RedeemForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formData = ref({
  id: undefined,
  name: undefined,
  orderNo: undefined,
  url: undefined,
  point: undefined,
  userId: undefined,
  contactName: undefined,
  contactAddress: undefined,
  contactPhone: undefined,
  status: undefined,
  remark: undefined
})
const formRules = reactive({
  orderNo: [{ required: true, message: '订单编号不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (id: number) => {
  dialogVisible.value = true
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await RedeemApi.getRedeem(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    await RedeemApi.updateRedeem(formData.value)
    message.success(t('common.updateSuccess'))
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    orderNo: undefined,
    url: undefined,
    point: undefined,
    userId: undefined,
    contactName: undefined,
    contactAddress: undefined,
    contactPhone: undefined,
    status: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}
</script>